
CoCoALib - Design #432

Semantics of IsPrintedWithMinus

31 Jan 2014 20:29 - John Abbott
Priority: Normal Due date:  

Assignee:  % Done: 10%

Category: Various Estimated time: 0.00 hour

Target version: CoCoALib-1.0 Spent time: 0.75 hour

Description

We should clarify what the semantics of IsPrintedWithMinus are.

I suggest that if IsPrintedWithMinus(x) gives true then IsPrintedWithMinus(-x) must give false; note that x and -x could both give

false e.g. if using least non neg residue for a prime finite field.

Related issues:

Related to CoCoALib - Feature #222: Printing polynomials - spaces between terms In Progress 08 Aug 2012

Related to CoCoALib - Feature #1117: Better printing of negative coeffs In Progress 07 Nov 2017

Related to CoCoALib - Design #1156: Printing for RingElem New 12 Feb 2018

History

#1 - 03 Feb 2014 12:49 - John Abbott

- Status changed from New to In Progress

If we follow the suggestion in note 6 of issue #222 then we need to define IsPrintedWithMinus only for numerical ringelems (i.e. ones for which

IsRational gives true).  If so, then there is an easy definition:

bool IsPrintedWithMinus(ConstRefRingElem x)

{

  BigRat q;

  return IsRational(q, x) && sign(q) == -1;

}

#2 - 03 Feb 2014 15:27 - John Abbott

Anna rightly asked how should TwinFloats be handled.

Right now, I'm undecided.  I'm quite sure that any polynomial with twinfloat coeffs will be very ugly/unreadable when printed.

#3 - 14 Jul 2014 18:13 - John Abbott

- Target version set to CoCoALib-1.0

- % Done changed from 0 to 10

If we use the definition I gave in comment 1 then some twin-float numbers will be recognized as rationals and should be printed out as such (I

suppose).  It could look a bit odd having a poly whose coeffs are partly rational and partly "floating-point"; then again a rational coeff is probably

important information (since I'd expect it to be a rare event).
#4 - 07 Nov 2017 12:34 - John Abbott

- Related to Feature #1117: Better printing of negative coeffs added

#5 - 12 Feb 2018 12:33 - John Abbott

- Related to Design #1156: Printing for RingElem added
